//+------------------------------------------------------------------+
//|                                                       HullMA.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow
//---- input parameters
extern int       periodoMA=12;
extern int       tipoPrecio=PRICE_MEDIAN;
extern int       tipoPromedio=MODE_LWMA;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
int        draw_begin0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   IndicatorBuffers(2);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
      Print("cannot set indicator buffers!");
//   ArraySetAsSeries(ind_buffer1,true);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   draw_begin0=periodoMA+MathFloor(MathSqrt(periodoMA));
   SetIndexDrawBegin(0,draw_begin0);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("HMA("+periodoMA+")");
   SetIndexLabel(0,"Hull Moving Average");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   double d1;
   double d2;   
   int limit;
//----
   if(counted_bars>0) counted_bars--;   
   limit=Bars-counted_bars;         
   for(int i=0; i<limit; i++){               
         d1=iMA(NULL,0,periodoMA,0,tipoPromedio,tipoPrecio,i);
         d2=iMA(NULL,0,MathRound(periodoMA/2),0,tipoPromedio,tipoPrecio,i);         
         ExtMapBuffer2[i]=(2*d2)-(d1);         
   }
   for(i=0; i<limit; i++)
           ExtMapBuffer1[i]=iMAOnArray(ExtMapBuffer2,0,MathSqrt(periodoMA),0,MODE_LWMA,i);
//----
   return(0);
  }
//+------------------------------------------------------------------+